// 
// Copyright (c) 2013-2016 Carsten Sonne Larsen <cs@innolan.dk>
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

using System.Collections.Generic;
using System.Linq;
using Ntp.Analyzer.Config.Node;
using Ntp.Analyzer.Config.Table;

namespace Ntp.Analyzer.Config.Syntax
{
    public sealed class RootSyntaxNode : SyntaxNode<Configuration>
    {
        public RootSyntaxNode()
            : base(Symbol.RootNode, null, 0)
        {
        }

        protected override Configuration InternalCompile()
        {
            var permission = Nodes.SingleOrDefault(n => n.Symbol == Symbol.KeywordPermission) as PermissionSyntaxNode;
            var daemon = Nodes.SingleOrDefault(n => n.Symbol == Symbol.KeywordDaemon) as HeartbeatSyntaxNode ??
                         Nodes.SingleOrDefault(n => n.Symbol == Symbol.KeywordService) as HeartbeatSyntaxNode;
            var database = Nodes.SingleOrDefault(n => n.Symbol == Symbol.KeywordDatabase) as DatabaseSyntaxNode;

            // TODO: Change to collection
            var notify = Nodes.SingleOrDefault(n => n.Symbol == Symbol.KeywordNotify) as NotifySyntaxNode;

            return new Configuration(
                Name,
                database?.Compile(),
                daemon?.Compile(),
                (permission ?? new PermissionSyntaxNode(null, 0)).Compile(),
                null, // NOTICE: Cluster function is not implemented
                notify?.Compile(),
                Nodes.OfType<ReadingSyntaxNode>().Select(n => n.Compile()),
                Nodes.OfType<ListenerSyntaxNode>().Select(n => n.Compile()),
                Nodes.OfType<LogSyntaxNode>().Select(n => n.Compile()),
                Nodes.OfType<HostSyntaxNode>().Select(n => n.Compile())
                );
        }

        protected override void ValidateMandatories()
        {
            CheckIsUnique(new List<Symbol>
            {
                Symbol.KeywordDatabase,
                Symbol.KeywordNotify,
                Symbol.KeywordPermission,
                Symbol.KeywordDaemon
            });

            CheckAllIsPresent(new List<Symbol>
            {
                Symbol.KeywordDatabase,
                Symbol.KeywordServer
            });
        }
    }
}